local ok, err = xpcall(function(...)
local tty = ...
io.stdin, io.stdout = tty, tty
local term = dofile('/lib/term.lua').wrap(io) --TODO require()

term:write(_VERSION, ' // ', _OSVERSION, '\n')

local env = setmetatable({}, {__index = _ENV}) --TODO pcall require() on __index

::repl::
local line, err = term:prompt({ fg = 0x00ff00, 'lua> ' })
if not line then
	if err == nil then --eof
		return
	elseif err == 'interrupted' then
		term:write('\n')
		goto repl
	else
		error(err)
	end
end

local f, err = load('return ' .. line, '=expr', 't', env)
if not f then f, err = load(line, '=repl', 't', env) end
if not f then
	term:error(tostring(err), '\n')
	goto repl
end

local results = table.pack(pcall(f))
if not results[1] then
	term:error('error: ', tostring(results[2]), '\n')
	goto repl
end

for i = 2, results.n do
	local val = results[i]
	local t = type(val)
	if i > 2 then term:write('\t') end
	if t == 'nil' or t == 'boolean' or t == 'number' then
		term:write({ fg = 0xffff00, tostring(val) })
	elseif t == 'string' then
		term:write({ fg = 0x9292ff, string.format('%q', val) })
	else
		term:write({ fg = 0xff80ff, tostring(val) })
	end
end

if results.n > 1 then term:write('\n') end

goto repl
end, function(e) return debug.traceback(tostring(e)) end, ...)
if not ok then error(err, 0) end

-- vi: set ts=2:
